"use strict";var e=require("http-status"),t=require("winston"),r=require("joi"),s=require("@aws-sdk/lib-dynamodb"),a=require("@aws-sdk/client-dynamodb"),n=require("@aws-sdk/client-sqs"),o=require("@aws-sdk/client-cognito-identity-provider"),d=require("@middy/core"),i=require("@middy/event-normalizer"),u=require("@middy/http-event-normalizer"),m=require("@middy/http-json-body-parser"),l=require("crypto");function c(e){var t=Object.create(null);return e&&Object.keys(e).forEach((function(r){if("default"!==r){var s=Object.getOwnPropertyDescriptor(e,r);Object.defineProperty(t,r,s.get?s:{enumerable:!0,get:function(){return e[r]}})}})),t.default=e,Object.freeze(t)}var g=c(r);class S extends Error{constructor(e,t){super(),this.name="HttpError",this.statusCode=500,this.statusCode=t,"string"==typeof e&&(this.message=e),e instanceof Error&&(this.message=e.message)}}class f extends Error{constructor(e,t,r){super(),this.name="ServiceError",this.code=500,this.statusCode=500,this.code=t||500,this.statusCode=r||500,"string"==typeof e&&(this.message=e),e instanceof Error&&(this.message=e.message)}}class p extends S{constructor(t){super(t||e[`${e.BAD_REQUEST}_MESSAGE`],e.BAD_REQUEST),this.name="BadRequestError"}}function C(e){const{error:t,value:r}=e.validate(process.env,{abortEarly:!1,allowUnknown:!0});if(t)throw console.warn(`Configuration is invalid. Detail: ${t}`),new f(`Configuration validation failed. ${t.message}`);return r}const E=g.object({AWS_EXECUTION_ENV:g.string().required(),AWS_LAMBDA_FUNCTION_NAME:g.string().required(),AWS_LAMBDA_FUNCTION_MEMORY_SIZE:g.string().required(),AWS_LAMBDA_FUNCTION_VERSION:g.string().required(),AWS_REGION:g.string().required(),LOGGING_ENABLED:g.boolean().default(!0),LOGGING_LEVEL:g.string().allow("debug","info","warn","error").default("info")}),h=C(E),v={validateConfig:C},{combine:y,json:w,timestamp:N}=t.format,b={format:y(N(),w()),level:h.LOGGING_LEVEL,silent:!h.LOGGING_ENABLED,transports:[new t.transports.Console]},I=t.createLogger(b);I.debug("Logger::creating new Logger");const D={defaultMessage:"Unhandled error",defaultStatusCode:500},O=e=>{const t={...D,...e};return{onError:e=>{if(void 0!==e.response)return;if(!e.error)return;const{error:r}=e;(e=>e instanceof S)(r)?(I.error(`middleware::http-error-handler::HttpError::${r}`,r),e.response={statusCode:r.statusCode??t.defaultStatusCode,body:JSON.stringify({name:r.name,message:r.message??t.defaultMessage,code:r.statusCode??t.defaultStatusCode,statusCode:r.statusCode??t.defaultStatusCode})}):(e=>e instanceof f)(r)?(I.error(`middleware::http-error-handler::ServiceError::${r}`,r),e.response={statusCode:r.statusCode??t.defaultStatusCode,body:JSON.stringify({name:r.name,message:r.message||t.defaultMessage,code:r.code||t.defaultStatusCode,statusCode:r.statusCode||t.defaultStatusCode})}):(I.error(`middleware::http-error-handler::Error::${r}`,r),e.response={statusCode:t.defaultStatusCode??500,body:JSON.stringify({name:r.name,message:r.message??t.defaultMessage,code:t.defaultStatusCode,statusCode:t.defaultStatusCode})})}}},_=()=>({before:e=>{I.defaultMeta={requestId:e.context.awsRequestId}}}),x={abortEarly:!1,allowUnknown:!0},M=e=>({before:t=>{if(I.debug("middleware::validator::before"),e.eventSchema){const{error:r,value:s}=((e,t)=>e.validate(t,x))(e.eventSchema,t.event);if(r)throw I.error(`middleware::validator::error::${r}`),new p(r.message);t.event={...t.event,...s}}}}),A={region:h.AWS_REGION},G={convertEmptyValues:!1,removeUndefinedValues:!0,convertClassInstanceToMap:!0},q={wrapNumbers:!1},L={marshallOptions:G,unmarshallOptions:q};I.debug("DynamoService::creating new DynamoDBDocumentClient",{data:{dynamoDbClientConfig:A,marshallOptions:G,unmarshallOptions:q}});const U=s.DynamoDBDocumentClient.from(new a.DynamoDBClient(A),L),B={batchWriteItems:e=>U.send(new s.BatchWriteCommand(e)),deleteItem:e=>U.send(new s.DeleteCommand(e)),getItem:e=>U.send(new s.GetCommand(e)),putItem:e=>U.send(new s.PutCommand(e)),queryItems:e=>U.send(new s.QueryCommand(e)),scanItems:e=>U.send(new s.ScanCommand(e)),updateItem:e=>U.send(new s.UpdateCommand(e))},R={region:h.AWS_REGION};I.debug("SQSService::creating new SQSClient",{data:{clientConfig:R}});const T=new n.SQSClient(R),F={sendMessage:e=>T.send(new n.SendMessageCommand(e))},W={send:async(e,t)=>{await F.sendMessage({QueueUrl:t,MessageBody:JSON.stringify({data:e.templateData,destinations:e.destinations,template:e.templateName})})}},j={region:h.AWS_REGION},Q=new o.CognitoIdentityProviderClient(j),$={adminDisableUser:e=>Q.send(new o.AdminDisableUserCommand(e)),adminSetUserPassword:e=>Q.send(new o.AdminSetUserPasswordCommand(e)),listUsers:e=>Q.send(new o.ListUsersCommand(e))},P={generate:(e=16)=>{let t=e;(e<1||e>128)&&(t=16);const r=Math.ceil(t/2);return l.randomBytes(r).toString("hex").substring(0,t)},ID_LENGTH_DEFAULT:16,ID_LENGTH_MAXIMUM:128,ID_LENGTH_MINIMUM:1};exports.BadRequestError=p,exports.CognitoIdentityProviderService=$,exports.ConfigService=v,exports.DynamoService=B,exports.EmailService=W,exports.ForbiddenError=class extends S{constructor(t){super(t||e[`${e.FORBIDDEN}_MESSAGE`],e.FORBIDDEN),this.name="ForbiddenError"}},exports.HttpError=S,exports.ID=P,exports.Logger=I,exports.NotFoundError=class extends S{constructor(t){super(t||e[`${e.NOT_FOUND}_MESSAGE`],e.NOT_FOUND),this.name="NotFoundError"}},exports.SQSService=F,exports.ServiceError=f,exports.baseConfigSchema=E,exports.baseConfigValues=h,exports.httpErrorHandler=O,exports.loggerInitializer=_,exports.middyfyAPIGateway=e=>d(e.handler).use(_()).use(u()).use(m()).use(M({eventSchema:e.eventSchema})).use(O({defaultMessage:e.defaultErrorMessage,defaultStatusCode:e.defaultErrorStatusCode})),exports.middyfyLambda=e=>d(e.handler).use(_()).use(M({eventSchema:e.eventSchema})),exports.middyfySNS=e=>d(e.handler).use(_()).use(i()).use(M({eventSchema:e.eventSchema})),exports.middyfySQS=e=>d(e.handler).use(_()).use(i()).use(M({eventSchema:e.eventSchema})),exports.middyfyScheduled=e=>d(e.handler).use(_()).use(M({eventSchema:e.eventSchema})),exports.validator=M;
//# sourceMappingURL=index.js.map
